"use strict";

var yami = typeof(yami) == "undefined" ? {} : yami;

yami.winmenu = {
	init: function() {
		Components.utils.import("resource://gre/modules/Services.jsm");
		this.wmds = Components
			.classes["@mozilla.org/rdf/datasource;1?name=window-mediator"]
			.getService(Components.interfaces.nsIWindowDataSource);
	},

	checkFocusedWindow: function() {
		let sep;
		let url;
		let wnd;
		sep = document.getElementById("sep-window-list");
		while((sep = sep.nextSibling)) {
			url = sep.getAttribute("id");
			wnd = this.wmds.getWindowForResource(url);
			if(wnd == window) {
				sep.setAttribute("checked", "true");
				break;
			}
		}
	},

	/* eslint-disable-next-line camelcase */
	appmenu_checkFocusedWindow: function() {
		let sep;
		let url;
		let wnd;
		sep = document.getElementById("appmenu_sep-window-list");
		while((sep = sep.nextSibling)) {
			url = sep.getAttribute("id");
			wnd = this.wmds.getWindowForResource(url);
			if(wnd == window) {
				sep.setAttribute("checked", "true");
				break;
			}
		}
	},

	showWindowFromResource: function(node) {
		var wnd = null;
		var url = node.getAttribute("id");
		wnd = this.wmds.getWindowForResource(url);
		if (wnd)
			this.toOpenWindow(wnd);
	},

	toOpenWindow: function(wnd) {
		try {
			wnd.document.commandDispatcher.focusedWindow.focus();
		} catch(err) {
			wnd.focus();
		}
	},

	toNavigator: function() {
		if(this.cycleWindow("navigator:browser") == false)
			OpenBrowserWindow();
	},

	cycleWindow: function(type) {
		var topWindow = Services.wm.getMostRecentWindow(null);
		var enumerator;
		var firstWindow;
		var iWindow;
		enumerator = Services.wm.getEnumerator(type);
		firstWindow = enumerator.getNext();
		iWindow = firstWindow;
		while(iWindow != topWindow && enumerator.hasMoreElements())
			iWindow = enumerator.getNext();
		if(enumerator.hasMoreElements()) {
			iWindow = enumerator.getNext();
			this.toOpenWindow(iWindow);
			return iWindow;
		}
		if(firstWindow == topWindow)
			return false;
		this.toOpenWindow(firstWindow);
		return firstWindow;
	}
};

window.addEventListener("load", function load() {
	window.removeEventListener("load", load, false);
	yami.winmenu.init();
}, false);
